#include <stdio.h>
#include "util-ieee.h"
#include <math.h>

int main ()
{
  cfloat zero, mzero, un, deux, trois;
  cfloat upe, denor, ddenor;
  cfloat inf, minf, nan;
  cfloat pi, unsurtrois, unsursix;

  /* initialisation via des flottants */
  zero.f  = 0.0;
  mzero.f = -0.0;
  un.f    = 1.0;
  deux.f  = 2.0;
  trois.f = 3.0;

  cfloat_print(" zero", zero);
  cfloat_print("mzero", mzero);
  if (zero.f == mzero.f)
    printf("test : zero=mzero est vrai\n");
  else
    printf("test : zero=mzero est faux\n");
  cfloat_print("   un", un );
  cfloat_print(" deux", deux);
  cfloat_print("trois", trois);

  printf("----------------------------------------------------------\n");

  /* initialisation via la structure de donnees (sig,exp,man) */
  
  /*  1 + epsilon avec epsilon=2^(-23) */
  upe.s.sig=0;
  upe.s.exp=0+127;
  upe.s.man=1;

  cfloat_print("upe",upe);
  
  printf("----------------------------------------------------------\n");

  /* epsilon = */
  denor.s.sig = 0;
  denor.s.exp = 0;
  denor.s.man = (1<<22);
  ddenor.f = 2.0*denor.f;

  cfloat_print(" denor", denor);
  cfloat_print("2denor", ddenor);

  printf("----------------------------------------------------------\n");
  inf.f = 1.0/0.0;
  minf.f = -1.0/0.0;
  nan.f = inf.f + minf.f;

  cfloat_print(" inf", inf);
  cfloat_print("minf", minf);
  cfloat_print(" nan", nan);

  printf("----------------------------------------------------------\n");
  unsurtrois.f = 1.0/3.0;
  unsursix.f = 1.0/6.0;
  pi.f = M_PI;
  
  cfloat_print("1/3",unsurtrois);
  cfloat_print("1/6",unsursix);
  cfloat_print("pi",pi);

  return 0;
}
