#include <stdio.h>
#include <math.h>

typedef float func_t(float x);

/* integre f entre a et b avec n rectangles */
float integre(func_t *f, float a, float b, long n)
{
  int i;
  float x   = a;
  float s   = 0.0;
  float pas = (b-a)/(n-1);

  for (i=0 ; i<n ; i++)
    {
      s += f(x)*pas;
      x += pas;
    }

  return s;
}

/* ---------------------------------------------------------------- */

/* fonction a integrer */
float my_func(float x)
{
  return 1.0/x;
}

int main ()
{
  /* liste des nb de rectangles a tester */
  long t[] = {10,20,50,100,200,500,1000,2000,5000,10000,20000,50000,\
              100000,200000,500000,1000000,2000000,5000000,\
              10000000,20000000,50000000,100000000};
  /* taille de la liste */
  unsigned int tsize = sizeof(t)/sizeof(t[0])-1;

  /* divers */
  unsigned int i;
  float s;

  /* boucle pour chaque nb de rectangles */
  for (i=0 ; i<tsize ; i++)
    {
      s = integre((func_t*)my_func, 1.0, 2.0, t[i]);
      printf("%10ld %e\n",t[i],fabs(s-log(2)));
    }

  return 0;
}
