#ifndef __UTIL_IEEE
#define __UTIL_IEEE

/* ---------------------------------------------------------------- */
// union permettant a une meme variable (ici un mot de 32 bits)
// d'etre "accessible" a travers differents types (mais il n'y a 
// bien qu'un seul mot en memoire)
union __cfloat_u
{
  float f;        // mot de 32 bits considere comme un flottant
  unsigned int i; // mot de 32 bits considere comme un entier
  struct s {      // mot de 32 bits considere par morceaux
    unsigned int man:23; // LSB
    unsigned int exp:8;
    unsigned int sig:1;  // MSB
  } s;
};

typedef union __cfloat_u cfloat; 

/* ---------------------------------------------------------------- */

void cfloat_print_fraction(cfloat x)
{
  unsigned int i, m, p;

  m = x.s.man;
  p = 1 << 22;

  for (i=0 ; i<=22 ; i++)
    {
      if (m >= p)
	{
	  m -= p;
	  printf("1");
	}
      else
	{
	  printf("0");
	}

      p = p >> 1;
    }
}

/* ---------------------------------------------------------------- */

void cfloat_print(const char* s, cfloat x)
{
  printf("%s = %25.40e\n",s,x.f);
  printf("%s = %1u %3u(%4d) %9u\n",s,x.s.sig,x.s.exp,x.s.exp-127,x.s.man);
  printf("%s = %1u %3u(%4d) ",s,x.s.sig,x.s.exp,x.s.exp-127);
  if (x.s.exp == 0)
    printf("0.");
  else
    printf("1.");
  cfloat_print_fraction(x);
  printf("\n%s = %#10x\n",s,x.i);
}

/* ---------------------------------------------------------------- */
#endif
